# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2022/3/31
import os
from datetime import date, timedelta
from loguru import logger
import datetime
import json
import time

import requests
import urllib3

from main.common import Common
from main.feishu_lib import Feishu


class Demo:
    @classmethod
    def demo1(cls):
        download_video_resolution = "720*1280"
        download_video_width = download_video_resolution.split("*")[0]
        download_video_height = download_video_resolution.split("*")[-1]
        print(download_video_resolution)
        print(download_video_width)
        print(download_video_height)

    @classmethod
    def time(cls):
        # 推荐
        time1 = int(time.time()*1000)
        print(time1)
        # 不推荐
        time2 = round(time.time())*1000
        print(time2)

        # 统一获取当前时间
        now = datetime.datetime.now()
        print(type(now))
        print(f"now:{now}")
        # 昨天
        yesterday = (date.today() + timedelta(days=-1)).strftime("%Y-%m-%d")
        print(type(yesterday))
        print(f"昨天:{yesterday}")
        # 今天
        today = date.today()
        print(type(today))
        print(f"今天:{today}")
        # 明天
        tomorrow = (date.today() + timedelta(days=1)).strftime("%Y-%m-%d")
        print(type(tomorrow))
        print(f"明天:{tomorrow}")

    @classmethod
    def demo2(cls):
        s = "0"
        print(int(int(s) / 10))

    @classmethod
    def edit_str(cls):
        title_list = ["#上海战疫 上海累计感染超20万！这条被淹没的热搜，令全网泪目… 疫情一定要攻克，但所有人都不该遗忘这些弱者。#上海累计报告本土阳性感染者超20万例 #农民工",
                      "#重庆地火村 #地火村 #旅行",
                      "第79集 | 湖南最值得去的六个景区，每一个都是绝色…… #快手带你去旅行 #旅游胜地 #旅游",
                      "霸王条款不废除，断供有多可怕。 #涨知识 #生活小常识 # 生活常识",
                      "秦始皇还活着？地宫中有不明物体缓缓移动 #历史 #秦始皇 #新春寄语  @快手热点(O40300129)",
                      "#夏日荷花  #国花牡丹 #昙花一现",
                      "国内最良心的8个景区，这才是景区最该有的样子，看看你去过几个？ #旅行  #旅游 ",
                      "狗子呆在水里三天三夜，终于练成捕鱼神功，一口一个大鲶鱼 #狗狗  #神奇动物  #快手放映室  @快手热点(O40300129) ",
                      "#集结吧光合创作者  养鸡小伙：喂鸡摆出各种造型，被称为鸡司令。",
                      "89岁农民老艺人自食其力，街头卖艺表演“捏碎碗片”绝技，现场听到咔吱咔吱响，人狠功夫硬！这功夫已失传，以后再看不到了！#集结吧光合创作者 #农民 #街头表演  @快手光合作者助手(O40300118)  @快手热点(O40300129)  @我要上热门(O1907752910)",
                      "我国最贵最有名的三棵树，你知道哪三棵吗？#旅游 #旅行攻略 #黄山迎客松",
                      "潘长江带来热舞，蔡明 郭达也来了！太嗨了！歌词太棒了！ @快手涨粉助手(O1815060199)  @快手热点(O40300129)  @快手平台帐号(O90041) #潘长江 #搞笑 #集结吧光合创作者",
                      "#带你看世界 给大家带来一期烟花盛宴，希望大家能够喜欢，带上你的那个她一起来看吧 #烟花 #视觉震撼"
                      ]
        for title in title_list:
            title_split1 = title.split(" #")
            if title_split1[0] != "":
                title1 = title_split1[0]
            else:
                title1 = title_split1[0]

            title_split2 = title1.split(" #")
            if title_split2[0] != "":
                title2 = title_split2[0]
            else:
                title2 = title_split2[-1]

            title_split3 = title2.split("@")
            if title_split3[0] != "":
                title3 = title_split3[0]
            else:
                title3 = title_split3[-1]

            print(title3)
            title = title3.replace("\n", "").replace("#", "").replace("/", "").replace("\r", "")
            print(title)

        # new_title = re.compile(r'(#)(.*)(#)')
        # print(new_title.sub(r'', title))

    @classmethod
    def sensitive_words(cls):
        title_list = ["#上海战疫 上海累计感染超20万！这条被淹没的热搜，令全网泪目… 疫情一定要攻克，但所有人都不该遗忘这些弱者。#上海累计报告本土阳性感染者超20万例 #农民工",
                      "#重庆地火村 #地火村 #旅行",
                      "第79集 | 湖南最值得去的六个景区，每一个都是绝色…… #快手带你去旅行 #旅游胜地 #旅游",
                      "霸王条款不废除，断供有多可怕。 #涨知识 #生活小常识 # 生活常识",
                      "秦始皇还活着？地宫中有不明物体缓缓移动 #历史 #秦始皇 #新春寄语  @快手热点(O40300129)",
                      "#夏日荷花  #国花牡丹 #昙花一现",
                      "国内最良心的8个景区，这才是景区最该有的样子，看看你去过几个？ #旅行  #旅游 ",
                      "狗子呆在水里三天三夜，终于练成捕鱼神功，一口一个大鲶鱼 #狗狗  #神奇动物  #快手放映室  @快手热点(O40300129) ",
                      "#集结吧光合创作者  养鸡小伙：喂鸡摆出各种造型，被称为鸡司令。",
                      "89岁农民老艺人自食其力，街头卖艺表演“捏碎碗片”绝技，现场听到咔吱咔吱响，人狠功夫硬！这功夫已失传，以后再看不到了！#集结吧光合创作者 #农民 #街头表演  @快手光合作者助手(O40300118)  @快手热点(O40300129)  @我要上热门(O1907752910)",
                      "我国最贵最有名的三棵树，你知道哪三棵吗？#旅游 #旅行攻略 #黄山迎客松",
                      "潘长江带来热舞，蔡明 郭达也来了！太嗨了！歌词太棒了！ @快手涨粉助手(O1815060199)  @快手热点(O40300129)  @快手平台帐号(O90041) #潘长江 #搞笑 #集结吧光合创作者",
                      "#带你看世界 给大家带来一期烟花盛宴，希望大家能够喜欢，带上你的那个她一起来看吧 #烟花 #视觉震撼"
                      ]
        print(cls.kuaishou_sensitive_words())
        for title in title_list:
            for word in cls.kuaishou_sensitive_words():
                if word in title:
                    print(f"敏感词：{word}")
                    print(f"敏感词视频：{title}")
                    cls.kuaishou_sensitive_words().remove(word)
                else:
                    print(f"正常视频：{title}")
                    cls.kuaishou_sensitive_words().remove(word)

    @classmethod
    def logger(cls):
        # 日志路径
        log_dir = r"./logs/"
        log_path = os.getcwd() + os.sep + log_dir
        if not os.path.isdir(log_path):
            os.makedirs(log_path)

        # 日志参数
        log_name = time.strftime("%Y-%m-%d", time.localtime(time.time())) + '.log'

        # 日志不打印到控制台
        logger.remove(handler_id=None)
        # logger.add(log_dir+log_name, format="{time} {level} {message}",
        # level="INFO", rotation='5 MB', encoding='utf-8')
        logger.add(log_dir+log_name, level="INFO", rotation='13:56')
        return logger

    @classmethod
    def download_video(cls):
        video_url = "https://v2-h5.kwaicdn.com/ksc1/JEq3hgQmbaJq_sHzHNQnYGPNJ5XRHnUJ" \
                    "eT1nP2eHeVEnOkXxfdBGpkvLy9ZCTSLMjiRJqiUftrJgi5qZrrz-ROSGhNwhUHgX2Z" \
                    "u4XgAqNZS5Kp0p3GzFdsB9jgpH3VBtmBVwq4l8Or0YZV6MySJmh6mbVPqePrLdeQ9GxY" \
                    "yvMbj4Ds2Z9yXQ3X9knED5xafh.mp4?clientCacheKey=3xkisjhn2tnwf5w_b.mp4&tt" \
                    "=b&di=de8075d0&bp=60000&pkey=AAWdtvPdTRXTA9T3NIXmzYfB0em4XZCTrPJZkmFerVrc" \
                    "RFtBbzkvz2ZUVuiUJK3VrRt3w2_cn2y7tQr-dpqkeM7HInHNkaGnDbnFXe530Zm65RfEdzjzNx_ErSTX5YonXTg"
        Common.download_method("video", "video", video_url)

    @classmethod
    def time2(cls):
        time1 = "2022/06/01 18:50:12"
        timeStamp = int(time.mktime(time.strptime(time1, "%Y/%m/%d %H:%M:%S")))
        print(timeStamp)

    @classmethod
    def get_sheet(cls):
        sheet = Feishu.get_values_batch("follow", "kuaishou", "WFF4jw")
        Referer = sheet[2][3]
        NS_sig3 = sheet[3][3]
        NS_sig3_origin = sheet[4][3]
        did = sheet[5][3]
        session_key = sheet[6][3]
        unionid = sheet[7][3]
        eUserStableOpenId = sheet[8][3]
        openId = sheet[9][3]
        eOpenUserId = sheet[10][3]
        kuaishou_wechat_app_st = sheet[11][3]
        passToken = sheet[12][3]
        userId = sheet[13][3]
        print(f"Referer:{Referer}")
        print(f"NS_sig3:{NS_sig3}")
        print(f"NS_sig3_origin:{NS_sig3_origin}")
        print(f"NS_sig3_origin:{NS_sig3_origin}")
        print(f"did:{did}")
        print(f"session_key:{session_key}")
        print(f"unionid:{unionid}")
        print(f"eUserStableOpenId:{eUserStableOpenId}")
        print(f"openId:{openId}")
        print(f"eOpenUserId:{eOpenUserId}")
        print(f"kuaishou_wechat_app_st:{kuaishou_wechat_app_st}")
        print(f"passToken:{passToken}")
        print(f"userId:{userId}")

    # 小程序:关注/取消关注用户
    @classmethod
    def follow_unfollow(cls, log_type, is_follow):
        try:
            # 已关注的用户列表 uids
            uid_sheet = Feishu.get_values_batch(log_type, "kuaishou", "MGMsHE")
            for i in range(1, len(uid_sheet)):
                uid = uid_sheet[i][0]
                nick = uid_sheet[i][1]
                url = "https://wxmini-api.uyouqu.com/rest/wd/wechatApp/relation/follow?"
                headers = {
                    "content-type": "application/json",
                    "Accept-Encoding": "gzip,compress,br,deflate",
                    "User-Agent": 'Mozilla/5.0 (iPhone; CPU iPhone OS 14_7_1 like Mac OS X)'
                                  ' AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
                                  ' MicroMessenger/8.0.20(0x18001442) NetType/WIFI Language/zh_CN',
                    "Referer": "https://servicewechat.com/wx79a83b1a1e8a7978/595/page-frame.html"
                }
                params = {
                    "__NS_sig3": "baaaeedda97f238b91e7e4e593b0bec8406b379ffbfbf9f9f6f7f4ee",
                    "__NS_sig3_origin": "3sCt3iAAAAAAAAAAAAAAAwEQBv2b8ewCiEHD8iAAAAAJi0p4iunP2uUH /x7m67D394uxv2sVV0N0ZsfmbHMpA=="
                }
                cookies = {
                    "did": "wxo_89af779e76d329da37ea78c277c8231d04c4",
                    "preMinaVersion": "v3.109.0",
                    "sid": "kuaishou.wechat.app",
                    "appId": "ks_wechat_small_app_2",
                    "clientid": "13",
                    "client_key": "f60ac815",
                    "kpn": "WECHAT_SMALL_APP",
                    "kpf": "OUTSIDE_ANDROID_H5",
                    "language": "zh_CN",
                    "smallAppVersion": "v3.114.0",
                    "session_key": "123063b798c706796d4e71a229547fee14dabdecb85d119c5daf99720d496e428f529d03bc9dc1a53a8fab307b723b98d4a41a129df1be81f6bd42648be78e2f1e3b51c82bb92220bd0a7fb0683326fe9e683d1dbc4477fa82ecf2d873e008d8292098cbf9b10ced28053001",
                    "unionid": "V2:1230e9a914f904112e011801770f38cae60271569a62736a2ef09dd7ca29ae045e33e6f78bdefb82afeb667ed45d673aa4901a122bee54a2d0d74e96be5662a33544727a0aec2220a4eb707584694c0b041940f0508561ced8d6ff67cf9ec9b375e24c6cd059633a28053001",
                    "eUserStableOpenId": "123064f8109ddf7d6c901e62f30735f32d4cd4a3612c91f64a97cac9d2e1cf78b4df71461899fded9683bcda048f882b74bd1a1230b7186912344668bc4685735a9da9d9724a2220bf6363e2c4cc19738f2206e8c8c64afc5b310866590ceeb44c41abd6bf4e1d1d28053001",
                    "openId": "o5otV4_NGQt4gLzlk5CMDfTApN_g",
                    "eOpenUserId": "124073d987dfc4dc5c544f8056bf54b83ff2d4a1042cbd3f974e088a05826320ff7b1655aacae3bad8629e09c3248978309c6642d9c1af5b8b65ef4ac4851bb8c9141a12bb92bd9c2290489ba7a733708a4a446de8382220dc87c9a1a5c3a0c359645e188828c8ae25ac716c35f90cb47df44362b760b8e928053001",
                    "kuaishou.wechat.app_st": "ChZrdWFpc2hvdS53ZWNoYXQuYXBwLnN0EqAB6h_yylsMxiWgIgtBf1xjZYXDmsMvJ1B5J75XwcZ3X3CSJ6TCmJjZ8Mz1FFTQ7yEB3wrx3F40vuUtxKyn0Fsi4Jji2aTnKRHSQySNGSOiveeEWDyFnI9RqVxnaTrfMGF7jqBrqjk_ENl93vZTEL2wfYH1UlWIXiZoVNnBVcP_sXEpfr3dAZ3jUFXRG4XtVODrxpVOeF_gZTObCke6RoT-jBoSwdJwnczeQoOaE2Nj6iF-69fWIiCrxCOlzdzE2smcQ4sMv0VyLAHOTvQk9Y34pbuIsOjz7SgFMAE",
                    "passToken": "ChNwYXNzcG9ydC5wYXNzLXRva2VuEpABDZ3HmbtEmdzkv2_Bg9ZVBF9DtJSeYLHFurm1wx-4NmeiF_l-AfaIuMtUa0LeVhYH4XqXYxksQgS0UYzqbKyk2UF-rWn9Z0x-fawxyWB6_-fdiPtwq2lJOTU4Dcd1jDhsxUkoxSCmIyhNHC-3TCDxvIsWwumW9gYpxL5rQOlxWRVilCQ9RomJWmirVumgkgLBGhKgKyzmNjRDxLfpDU5SPFhJmG0iIIfnORJeG0u1E8FQjuNKf7CP1hA372VOpLRiYaaJxCj-KAUwAQ",
                    "userId": "1921947321"
                }

                if is_follow == "follow":
                    ftype = 1
                elif is_follow == "unfollow":
                    ftype = 2
                else:
                    ftype = 1

                json_text = {
                    "touid": uid,
                    "ftype": ftype,
                    "page_ref": 84
                }
                urllib3.disable_warnings()
                r = requests.post(url=url, headers=headers, cookies=cookies, params=params, json=json_text, verify=False)
                if is_follow == "follow":
                    if r.json()["result"] != 1:
                        Common.logger(log_type).warning("{}", r.text)
                    else:
                        Common.logger(log_type).info("关注:{}, {}", nick, r)
                else:
                    if r.json()["result"] != 1:
                        Common.logger(log_type).warning("{}", r.text)
                    else:
                        Common.logger(log_type).info("取消关注:{}, {}", nick, r)
                time.sleep(1)
        except Exception as e:
            Common.logger(log_type).error("关注/取消关注异常:{}", e)


if __name__ == "__main__":
    Demo.get_sheet()
    # demo.follow_unfollow("follow", "follow")

