# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2022/3/30
# import datetime
import datetime
import os
import random
import sys
import time
sys.path.append(os.getcwd())
from main.common import Common
from main.kuaishou_recommend_list import KuaiShou


def main():
    """
    执行正式环境快手脚本
    """
    while True:
        Common.logger("recommend").info("开始抓取快手推荐榜\n")
        # 抓取符合规则的视频，写入 kuaishou_feeds.txt
        KuaiShou.get_feeds("recommend")
        # 下载视频，并上传
        Common.logger("recommend").info("开始下载/上传视频\n")
        KuaiShou.run_download_publish("recommend", "prod")
        # 随机睡眠1-3s
        Common.logger("recommend").info("随机休眠 10 - 20 秒\n")
        time.sleep(random.randint(10, 20))
        # 删除冗余日志
        Common.del_logs("recommend")


if __name__ == "__main__":
    main()
